Subject: RE: [rohc] Doubt in UDVM Reg Variable state_length(SIGCOMP)

From: "Gangadharan G - TLS,Chennai" <[email-masked]>
Date: Wed, 22 Nov 2006 19:56:38 +0530

Hi Cristian,

Thanks for ur response.

So, It is NOT MUST for the UDVM module to update its Reg variable
state_length 
,after executing the STATE-ACCESS Instruction, with the no. of bytes copied.

If it so, the only way is to send the State_Length along with the compressed
message.
(if the states of fixed frame are not used).

If RFC 3320 mandates to update the state_length variable, then I don't need
to send the 
length along with the State-ID for the State-Access in my Bytecode. 

It put additional burden on the Bytecode to extract the state_length from
the compressed 
data and on the Compressor to store the state_length for all states that
will be accessed in the remote end.

RFC 3320 can mention some way to inform the bytecode about the no. of bytes
copied by State-Access instruction.

Please forgive me if I am ignorant on anything.

Thanks,
Gangadharan.

-----Original Message-----
From: cco [mailto:[email-masked]]
Sent: Wednesday, November 22, 2006 5:52 PM
To: Gangadharan G - TLS,Chennai
Cc: [email-masked]
Subject: Re: [rohc] Doubt in UDVM Reg Variable state_length(SIGCOMP)

On Tue, Nov 21, 2006 at 06:17:54PM +0530, Gangadharan G - TLS,Chennai wrote:
> Hi,
>  
> RFC 3320 Section 7.2.  Accessing Stored State (Page 26) specifies that,
>                      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
>                      |         state_length                     |  8 - 9
>                      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
>  
>    Addresses 6 to 9 are initialized to the length of the partial state
>    identifier, followed by the state_length from the retrieved state
>    item.  Both are expressed as 2-byte values.
> 

cristian: hi ganga! the useful values (the first 10 bytes of the udvm
memory) are initialized with the described values _only_ when the udvm
is initialized (i.e. begining of bytecode execution).

now, partial_state_ID_length and state_length in particular are
initialized only when the sigcomp message makes a state access using the 
partial state identifier in the sigcomp message header itself (rfc3320,
Figure 3: Format of a SigComp message); i.e. bytecode is _not_ present
in the message but partial state identifier is.

by checking these values during the bytecode execution you will be able
to know whether the bytecode came on the wire or was accesesd from a
saved state. (for not saving it again in the peer compartment 
for example...)

>  
> My Question is:
>  
> * Whether the UDVM Reg variable state_length has to updated, after
executing
> the STATE-ACCESS Instruction,
>    with the no. of bytes copied.

cristian: it is up to you whether you do it or not; the bytecode can use the
memory at the begining as a scratchpad.

>  
> * If not, then how Bytecode can know about the no. of bytes copied thro'
the
> STATE-ACCESS Instruction.
>   (Apart from the method that the Compressor has a knowledge about the
> state_length of that State).

cristian: you mean you are using STATE-ACCESS with a state_length=0
parameter and the state_length which was saved by a STATE-CREATE is used,
right?

in this case you have 2 options:

- either the bytecode knows exactly what the state_length is (for
example you are always using a fixed state_length of 1k)

- the compresor sends together with the compressed data the state length(s)
for the STATE-ACESSes in your bytecode.

bye now!
cristian

_______________________________________________
Rohc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rohc
DISCLAIMER 
The contents of this e-mail and any attachment(s) are confidential and intended for the 

named recipient(s) only. It shall not attach any liability on the originator or HCL or its 

affiliates. Any views or opinions presented in this email are solely those of the author and 

may not necessarily reflect the opinions of HCL or its affiliates. Any form of reproduction, 

dissemination, copying, disclosure, modification, distribution and / or publication of this 

message without the prior written consent of the author of this e-mail is strictly 

prohibited. If you have received this email in error please delete it and notify the sender 

immediately. Before opening any mail and attachments please check them for viruses and 

defect.

_______________________________________________
Rohc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rohc

---

From: cco <[email-masked]>
Date: Wed, 22 Nov 2006 15:42:48 +0100

> ,after executing the STATE-ACCESS Instruction, with the no. of bytes copied.

cristian: udvm has _nothing_ to do with it; it is just executing the
bytecode. if the _bytecode_ does it then the value is updated; otherwise
not. this is what I meant.

> copied by State-Access instruction.

cristian: in the case state_length==0 in the STATE_ACCESS it is up to
your compressor/bytecode identifying the length of the accessed state.

bye now!
cristian